<template>
  <div class="tenant">
    <!-- <Banner /> -->
    <div class="content">
      <byTable
        :source="sourceList.data"
        :pagination="sourceList.pagination"
        :config="config"
        :loading="loading"
        highlight-current-row
        :selectConfig="selectConfig"
        :table-events="{
          //element talbe事件都能传
          select: select,
        }"
        :action-list="[
          {
            text: '添加供应价格',
            action: () => openModal('add'),
          },
        ]"
        @get-list="getList"
      >
        <template #fileSlot="{ item }">
          <div
            style="cursor: pointer; color: #409eff"
            @click="handleClickFile(item)"
          >
            {{ item.fileName }}
          </div>
        </template>
      </byTable>
    </div>
    <el-dialog
      :title="modalType == 'add' ? '添加供应价格' : '编辑供应价格'"
      v-model="dialogVisible"
      width="800"
      v-loading="loading"
    >
      <byForm
        :formConfig="formConfig"
        :formOption="formOption"
        v-model="formData.data"
        :rules="rules"
        ref="byform"
      >
        <template #details>
          <div style="width: 100%">
            <el-button
              type="primary"
              @click="openProduct = true"
              :disabled="modalType == 'edit'"
            >
              选择
            </el-button>

            <el-form
              ref="tableForm"
              :model="formData.data"
              :rules="rules"
              label-width="0px"
              style="margin-top: 15px"
            >
              <el-table :data="formData.data.supplierPriceList">
                <el-table-column prop="code" label="货品编码" />
                <el-table-column prop="name" label="货品名称" min-width="150" />
                <el-table-column prop="spec" label="规格型号" />
                <el-table-column
                  prop="unit"
                  label="单位"
                  :formatter="(row) => dictValueLabel(row.unit, productUnit)"
                />
                <el-table-column prop="price" label="供应单价" min-width="150">
                  <template #default="{ row, $index }">
                    <el-form-item
                      :prop="'supplierPriceList.' + $index + '.price'"
                      :rules="rules.price"
                      :inline-message="true"
                    >
                      <el-input-number
                        v-model="row.price"
                        :precision="4"
                        :controls="false"
                        :min="1"
                      />
                    </el-form-item>
                  </template>
                </el-table-column>

                <el-table-column prop="zip" label="操作" width="100">
                  <template #default="{ $index }">
                    <el-button
                      type="primary"
                      link
                      @click="handleRemove($index)"
                      :disabled="modalType == 'edit'"
                      >删除</el-button
                    >
                  </template>
                </el-table-column>
              </el-table>
            </el-form>
          </div>
        </template>
      </byForm>
      <template #footer>
        <el-button @click="dialogVisible = false" size="large">取 消</el-button>
        <el-button
          type="primary"
          @click="submitForm('byform')"
          size="large"
          :loading="submitLoading"
        >
          确 定
        </el-button>
      </template>
    </el-dialog>

    <el-dialog
      v-model="openProduct"
      title="选择货品"
      width="70%"
      append-to-body
    >
      <SelectGoods
        @cancel="openProduct = false"
        @pushGoods="pushGoods"
      ></SelectGoods>
    </el-dialog>
  </div>
</template>
  
<script setup>
/* eslint-disable vue/no-unused-components */
import { ElMessage, ElMessageBox } from "element-plus";
import byTable from "@/components/byTable/index";
import byForm from "@/components/byForm/index";
import FileUpload from "@/components/FileUpload/index";
import { computed, defineComponent, ref } from "vue";
import { getToken } from "@/utils/auth";
import SelectGoods from "@/components/product/SelectGoods";

const uploadFileUrl = ref(import.meta.env.VITE_APP_BASE_API + "/common/upload"); // 上传文件服务器地址
const headers = ref({ Authorization: "Bearer " + getToken() });
const uploadData = ref({});
const loading = ref(false);
const submitLoading = ref(false);
const sourceList = ref({
  data: [],
  pagination: {
    total: 3,
    pageNum: 1,
    pageSize: 10,
  },
});
let dialogVisible = ref(false);
let openProduct = ref(false);

let modalType = ref("add");
let fileList = ref([]);
let rules = ref({
  supplierInfoId: [
    { required: true, message: "请选择供应商", trigger: "change" },
  ],
  price: [{ required: true, message: "请输入供应单价", trigger: "blur" }],
});
const { proxy } = getCurrentInstance();
const selectConfig = reactive([
  {
    label: "供应商类型",
    prop: "supplierType",
    data: [
      {
        label: "贸易商",
        value: "1",
      },
      {
        label: "工厂",
        value: "2",
      },
    ],
  },
  {
    label: "货品类型",
    prop: "definition",
    data: [
      {
        label: "产品",
        value: "1",
      },
      {
        label: "物料",
        value: "2",
      },
    ],
  },
]);
const config = computed(() => {
  return [
    {
      attrs: {
        label: "货品类型",
        prop: "definition",
      },
      render(definition) {
        return definition === 1 ? "产品" : definition === 2 ? "物料" : "";
      },
    },
    {
      attrs: {
        label: "所属分类",
        prop: "productClassifyName",
      },
    },
    {
      attrs: {
        label: "货品编码",
        prop: "productCode",
      },
    },
    {
      attrs: {
        label: "货品名称",
        prop: "productName",
      },
    },
    {
      attrs: {
        label: "规格型号",
        prop: "productSpec",
      },
    },
    {
      attrs: {
        label: "单位",
        prop: "productUnit",
      },
      render(unit) {
        return proxy.dictValueLabel(unit, productUnit.value);
      },
    },
    {
      attrs: {
        label: "供应商类型",
        prop: "supplierType",
      },
      render(type) {
        return proxy.dictDataEcho(type, supplierType.value);
      },
    },
    {
      attrs: {
        label: "供应商名称",
        prop: "supplierName",
      },
    },
    {
      attrs: {
        label: "供应单价",
        prop: "price",
      },
    },
    {
      attrs: {
        label: "操作",
        width: "200",
        align: "right",
      },
      // 渲染 el-button，一般用在最后一列。
      renderHTML(row) {
        return [
          {
            attrs: {
              label: "修改",
              type: "primary",
              text: true,
            },
            el: "button",
            click() {
              getDtl(row);
            },
          },
          {
            attrs: {
              label: "删除",
              type: "danger",
              text: true,
            },
            el: "button",
            click() {
              // 弹窗提示是否删除
              ElMessageBox.confirm(
                "此操作将永久删除该数据, 是否继续?",
                "提示",
                {
                  confirmButtonText: "确定",
                  cancelButtonText: "取消",
                  type: "warning",
                }
              ).then(() => {
                // 删除
                proxy
                  .post("/supplierPrice/delete", {
                    id: row.id,
                  })
                  .then((res) => {
                    ElMessage({
                      message: "删除成功",
                      type: "success",
                    });
                    getList();
                  });
              });
            },
          },
        ];
      },
    },
  ];
});

let formData = reactive({
  data: {
    supplierPriceList: [],
  },
});
const formOption = reactive({
  inline: true,
  labelWidth: 100,
  itemWidth: 100,
  rules: [],
});
const byform = ref(null);
const formConfig = reactive([
  {
    type: "select",
    prop: "supplierInfoId",
    label: "供应商",
    required: true,
    disabled: false,
    filterable: true,
    isLoad: {
      url: "/supplierInfo/page",
      req: {
        pageNum: 1,
        pageSize: 9999,
      },
      labelKey: "name",
      labelVal: "id",
      method: "post",
      resUrl: "rows",
    },
  },
  {
    type: "slot",
    slotName: "details",
    prop: "supplierPriceList",
    label: "供应明细",
    required: true,
  },
]);
const getList = async (req) => {
  sourceList.value.pagination = { ...sourceList.value.pagination, ...req };
  loading.value = true;
  proxy
    .post("/supplierPrice/page", sourceList.value.pagination)
    .then((message) => {
      console.log(message);
      sourceList.value.data = message.rows;
      sourceList.value.pagination.total = message.total;
      setTimeout(() => {
        loading.value = false;
      }, 200);
    });
};
const openModal = () => {
  dialogVisible.value = true;
  modalType.value = "add";
  formConfig[0].disabled = false;
  formData.data = {
    supplierPriceList: [],
    renewWhileItExists: false,
  };
};

const submitForm = () => {
  byform.value.handleSubmit((valid) => {
    if (formData.data.supplierPriceList.length > 0) {
      proxy.$refs.tableForm.validate((vaild) => {
        if (vaild) {
          if (!formData.data.id) {
            const submitData = {
              ...formData.data,
              supplierPriceList: formData.data.supplierPriceList.map((x) => ({
                productInfoId: x.productInfoId,
                price: x.price,
              })),
            };
            submitLoading.value = true;
            proxy.post("/supplierPrice/" + modalType.value, submitData).then(
              (res) => {
                if (res.addSuccess) {
                  ElMessage({
                    message: modalType.value == "add" ? "添加成功" : "编辑成功",
                    type: "success",
                  });
                  getList();
                  dialogVisible.value = false;
                  submitLoading.value = false;
                } else {
                  ElMessage({
                    message: `已存在供应价格,价格为${res.existSupplierPriceList[0].price}`,
                    type: "info",
                  });
                  ElMessageBox.confirm(
                    "继续提交将修改已存在的单价数据, 是否继续?",
                    "提示",
                    {
                      confirmButtonText: "确定",
                      cancelButtonText: "取消",
                      type: "warning",
                    }
                  )
                    .then(() => {
                      const arr = [];
                      for (
                        let i = 0;
                        i < formData.data.supplierPriceList.length;
                        i++
                      ) {
                        const iele = formData.data.supplierPriceList[i];
                        for (
                          let j = 0;
                          j < res.existSupplierPriceList.length;
                          j++
                        ) {
                          const jele = res.existSupplierPriceList[j];
                          if (iele.productInfoId === jele.productInfoId) {
                            jele.price = iele.price;
                            arr.push(jele);
                          }
                        }
                      }
                      formData.data.supplierPriceList = arr.map((x) => ({
                        productInfoId: x.productInfoId,
                        price: x.price,
                      }));
                      formData.data.renewWhileItExists = true;
                      proxy
                        .post(
                          "/supplierPrice/" + modalType.value,
                          formData.data
                        )
                        .then((res) => {
                          if (res.addSuccess) {
                            ElMessage({
                              message: "修改成功",
                              type: "success",
                            });
                            getList();
                            dialogVisible.value = false;
                            submitLoading.value = false;
                          }
                        });
                    })
                    .catch(() => {});
                }
              },
              (err) => {
                submitLoading.value = false;
              }
            );
          } else {
            formData.data.supplierInfoId = formData.data.supplierInfoIdCopy;
            formData.data.productInfoId =
              formData.data.supplierPriceList[0].productInfoId;
            formData.data.price = formData.data.supplierPriceList[0].price;
            delete formData.data.supplierPriceList;
            delete formData.data.supplierInfoIdCopy;
            proxy
              .post("/supplierPrice/" + modalType.value, formData.data)
              .then((res) => {
                ElMessage({
                  message: "修改成功",
                  type: "success",
                });
                getList();
                dialogVisible.value = false;
                submitLoading.value = false;
              });
          }
        }
      });
    } else {
      return ElMessage({
        message: "请添加供应明细！",
        type: "info",
      });
    }
  });
};

const getDtl = (row) => {
  modalType.value = "edit";
  formConfig[0].disabled = true;
  dialogVisible.value = true;
  formData.data = {
    id: row.id,
    supplierInfoIdCopy: row.supplierInfoId,
    supplierInfoId: row.supplierName,
    supplierPriceList: [
      {
        productInfoId: row.productInfoId,
        name: row.productName,
        code: row.productCode,
        unit: row.productUnit,
        spec: row.productSpec,
        price: row.price,
      },
    ],
  };
};

// const handleClickFile = (row) => {
//   ElMessage({
//     message: "数据请求中，请稍后！",
//     type: "success",
//   });
//   let id = row.id;
//   proxy.post("/fileInfo/getList", { businessIdList: [id] }).then((res) => {
//     const file = res[id][0];
//     window.open(file.fileUrl, "_blank");
//   });
// };

const handleRemove = (index) => {
  formData.data.supplierPriceList.splice(index, 1);
  return ElMessage({
    message: "删除成功！",
    type: "success",
  });
};

const pushGoods = (goods) => {
  const arr = goods.map((x) => ({ ...x, productInfoId: x.id, price: "" }));
  arr.forEach((item) => {
    if (!formData.data.supplierPriceList.some((e) => e.id === item.id)) {
      formData.data.supplierPriceList.push(item);
    }
  });
  openProduct.value = false;
  return ElMessage({
    message: "添加成功！",
    type: "success",
  });
};
const supplierType = ref([]);
const productUnit = ref([]);
const getDict = () => {
  proxy.getDictOne(["supplier_type", "unit"]).then((res) => {
    supplierType.value = res["supplier_type"];
    selectConfig[0].data = supplierType.value.map((x) => ({
      label: x.dictValue,
      value: x.dictKey,
    }));
    productUnit.value = res["unit"].map((x) => ({
      label: x.dictValue,
      value: x.dictKey,
    }));
  });
};
getDict();
getList();
</script>
  
<style lang="scss" scoped>
.tenant {
  padding: 20px;
}
</style>